#pragma once

#include <cassert>

#include "graph.h"

void graph_optimize(Graph &G, long long &k);


#define NUM_RULES 16

enum optimization_rules {
	OPT_NONE,
	OPT_TWIN,
	OPT_KPLUS_DISJOINT,
	OPT_PERMANENT_CLUB,
	OPT_SIMPLE_CHOICE,
	OPT_2CLUB_PURGE
};

extern optimization_rules enabled_rules[NUM_RULES];
